<template>
<!-- eslint-disable -->
  <v-container
    id="regular-tables"
    fluid
    tag="section"
  >
    <v-data-table
      dense
      :headers="headers"
      :items="workItems"
      :items-per-page="1000"
      class="elevation-1"
    >
    <template v-slot:top>
      <v-toolbar flat color="white">
        <v-dialog v-model="openCreation" max-width="500px">
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              rounded
              color="primary"
              dark
              class="mb-2"
              v-bind="attrs"
              v-on="on"
            >Adauga Lucrare</v-btn>
          </template>
          <v-card>
            <v-card-title>
              <span class="headline">{{ creationTitle }}</span>
            </v-card-title>

            <v-card-text>
              <v-container>
                <v-row>
                  <v-col cols="12" sm="6" md="4">
                    <v-text-field v-model="newItem.name" label="Nume"></v-text-field>
                  </v-col>
                  <v-col cols="12" sm="6" md="4">
                    <v-text-field v-model="newItem.email" label="Email"></v-text-field>
                  </v-col>
                  <v-col cols="12" sm="6" md="4">
                    <v-text-field v-model="newItem.adresa_lucrare" label="Adresa lucrare"></v-text-field>
                  </v-col>
                  <v-col cols="12" sm="6" md="4">
                    <v-combobox
                      v-model="newItem.tip_lucrare"
                      :items="tipuriLucrari"
                      :search-input.sync="search"
                      hide-selected
                      label="Tip lucrare"
                      persistent-hint
                      clearable
                    >
                      <template v-slot:no-data>
                        <v-list-item>
                          <v-list-item-content>
                            <v-list-item-title>
                              Niciun rezultat pentru tipul "<strong>{{ search }}</strong>".
                            </v-list-item-title>
                          </v-list-item-content>
                        </v-list-item>
                      </template>
                    </v-combobox>
                  </v-col>
                  <v-col cols="12" sm="6" md="4">
                    <v-checkbox
                      :label="'Autorizatie Contract'"
                      v-model="newItem.autorizatie_contract"
                      :color="contractColor(newItem.autorizatie_contract)"
                    ></v-checkbox>
                  </v-col>
                  <v-col cols="12" sm="6" md="4">
                    <v-checkbox
                      :label="'Contract'"
                      v-model="newItem.contract"
                      :color="contractColor(newItem.contract)"
                    ></v-checkbox>
                  </v-col>
                </v-row>
              </v-container>
            </v-card-text>

            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue darken-1" text @click.once="close">Cancel</v-btn>
              <v-btn color="blue darken-1" text @click.once="save">Save</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-toolbar>
    </template>
    <template v-slot:item.autorizatie_contract="{ item }">
      <v-simple-checkbox
        v-model="item.autorizatie_contract"
      ></v-simple-checkbox>
    </template>
    <template v-slot:item.contract="{ item }">
      <v-simple-checkbox
        class="disableCondition"
        v-model="item.contract"
        :color="contractColor(item.contract)"
      ></v-simple-checkbox>
    </template>
    </v-data-table>
  </v-container>
</template>

<script>
  import * as Cfg from '@/middleware/configSettings.ts'
  // import { getRequest } from '@/middleware/apicalls.ts'

  const axios = require('axios')

  export default {
    data () {
      return {
        headers: [
          {
            text: 'Nr.crt',
            sortable: false,
            value: 'id',
          },
          {
            text: 'Client',
            align: 'start',
            sortable: false,
            value: 'name',
          },
          {
            text: 'Email',
            sortable: false,
            value: 'email',
          },
          {
            text: 'Adresa lucrare',
            sortable: false,
            value: 'adresa_lucrare',
          },
          {
            text: 'Tip lucrare',
            sortable: false,
            value: 'tip_lucrare',
          },
          {
            text: 'Autorizatie contract',
            sortable: false,
            value: 'autorizatie_contract',
          },
          {
            text: 'Contract',
            sortable: false,
            value: 'contract',
          },
        ],
        workItems: [],
        creationTitle: 'Lucrare noua',
        openCreation: false,
        newItem: {
          name: '',
          email: '',
          adresa_lucrare: '',
          tip_lucrare: '',
          autorizatie_contract: false,
          contract: false,
        },
        defaultItem: {
          name: '',
          email: '',
          adresa_lucrare: '',
          tip_lucrare: '',
          autorizatie_contract: false,
          contract: false,
        },
        tipuriLucrari: [
          'Ext',
          'Dev.',
          'Br. CU',
          'Br. AC',
        ],
        search: null,
      }
    },
    created () {
      this.init()
    },
    methods: {
      init () {
        const url = Cfg.url.urlWorks
        axios.get(url).then(resp => {
          this.workItems = resp.data.payload
        })
      },
      contractColor (isChecked) {
        return isChecked ? 'success' : 'error'
      },
      close () {
        this.openCreation = false
        this.newItem = this.defaultItem
        console.log('closed')
      },
      save () {
        console.log('saved')
        this.newItem = this.defaultItem
        this.openCreation = false
      },
    },
  }
</script>
<style scoped>
.disableCondition {
  pointer-events: none
}
</style>
